Unit AEG2C_p;
interface
uses
SysUtils, Math, { Delphi }
Lstruct, Lfunc, UTAE10_p;

procedure AEG2C(N :Integer; var AR :Array of Real;
                var AI :Array of Real; var EVR :Array of Real;
                var EVI :Array of Real; IEER :Integer);

implementation

procedure AEG2C(N :Integer; var AR :Array of Real;
                var AI :Array of Real; var EVR :Array of Real;
                var EVI :Array of Real; IEER :Integer);
var
IERR,IR1,IR2,A,B,C,D,E,F,G,H,R,S,T,U,V,W,X,Y :Integer;
K,L,M,O,P,Q,Z,BA,BB,BC,BD,BE,BF,BG,BH,BI,BJ :Real;
BL :Complex;
const
SYS051 :Real = 1.192093E-07;
label
_1,_2,_3,_4,_5,_6,_7,_8,_9,_10,_11,_12,_13,_14,_15,_16,_17,_18,_19,
_20,_21,_22,_23,_24,_25,_26,_27,_28,_29,_30,_31,_32,_33,_34,_35;
begin
IR1 := 1;
IR2 := N;
F := IR2-1;
H := IR1+1;
if ( F < H ) 
 then goto _12;
for C:=H to F do
 begin
  M := 0.0;
  EVR[C-1] := 0.0;
  EVI[C-1] := 0.0;
  Q := 0.0;
  for A:=C to IR2 do
   begin
_1:
    Q := Q+Abs(AR[(A-1)+(C-2)*N])+Abs(AI[(A-1)+(C-2)*N]);
   end;
  if ( Q = 0.0 ) 
   then goto _11;
  G := C+IR2;
  for D:=C to IR2 do
   begin
    A := G-D;
    EVR[A-1] := AR[(A-1)+(C-2)*N]/Q;
    EVI[A-1] := AI[(A-1)+(C-2)*N]/Q;
    M := M+EVR[A-1]*EVR[A-1]+EVI[A-1]*EVI[A-1];
_2:
   end;
  L := Sqrt(M);
  K := Cabs(Cmplx(EVR[C-1],EVI[C-1]));
  if ( K = 0.0 ) 
   then goto _3;
  M := M+K*L;
  L := L/K;
  EVR[C-1] := (1.0+L)*EVR[C-1];
  EVI[C-1] := (1.0+L)*EVI[C-1];
  goto _4;
_3:
  EVR[C-1] := L;
  AR[(C-1)+(C-2)*N] := Q;
_4:
  for B:=C to N do
   begin
    P := 0.0;
    O := 0.0;
    for D:=C to IR2 do
     begin
      A := G-D;
      P := P+EVR[A-1]*AR[(A-1)+(B-1)*N]+EVI[A-1]*AI[(A-1)+(B-1)*N];
      O := O+EVR[A-1]*AI[(A-1)+(B-1)*N]-EVI[A-1]*AR[(A-1)+(B-1)*N];
_5:
     end;
    P := P/M;
    O := O/M;
    for A:=C to IR2 do
     begin
      AR[(A-1)+(B-1)*N] := AR[(A-1)+(B-1)*N]-P*EVR[A-1]+O*EVI[A-1];
      AI[(A-1)+(B-1)*N] := AI[(A-1)+(B-1)*N]-P*EVI[A-1]-O*EVR[A-1];
_6:
     end;
_7:
   end;
  for A:=1 to IR2 do
   begin
    P := 0.0;
    O := 0.0;
    for E:=C to IR2 do
     begin
      B := G-E;
      P := P+EVR[B-1]*AR[(A-1)+(B-1)*N]-EVI[B-1]*AI[(A-1)+(B-1)*N];
      O := O+EVR[B-1]*AI[(A-1)+(B-1)*N]+EVI[B-1]*AR[(A-1)+(B-1)*N];
_8:
     end;
    P := P/M;
    O := O/M;
    for B:=C to IR2 do
     begin
      AI[(A-1)+(B-1)*N] := AI[(A-1)+(B-1)*N]+P*EVI[B-1]-O*EVR[B-1];
      AR[(A-1)+(B-1)*N] := AR[(A-1)+(B-1)*N]-P*EVR[B-1]-O*EVI[B-1];
_9:
     end;
_10:
   end;
  EVR[C-1] := Q*EVR[C-1];
  EVI[C-1] := Q*EVI[C-1];
  AR[(C-1)+(C-2)*N] := -L*AR[(C-1)+(C-2)*N];
  AI[(C-1)+(C-2)*N] := -L*AI[(C-1)+(C-2)*N];
_11:
 end;
_12:
IERR := 0;
if ( IR1 = IR2 ) 
 then goto _16;
T := IR1+1;
for R:=T to IR2 do
 begin
  V := Min0(R+1,IR2);
  if ( AI[(R-1)+(R-2)*N] = 0.0 ) 
   then goto _15;
  BJ := Cabs(Cmplx(AR[(R-1)+(R-2)*N],AI[(R-1)+(R-2)*N]));
  BG := AR[(R-1)+(R-2)*N]/BJ;
  BF := AI[(R-1)+(R-2)*N]/BJ;
  AR[(R-1)+(R-2)*N] := BJ;
  AI[(R-1)+(R-2)*N] := 0.0;
  for S:=R to IR2 do
   begin
    Z := BG*AI[(R-1)+(S-1)*N]-BF*AR[(R-1)+(S-1)*N];
    AR[(R-1)+(S-1)*N] := BG*AR[(R-1)+(S-1)*N]+BF*AI[(R-1)+(S-1)*N];
    AI[(R-1)+(S-1)*N] := Z;
_13:
   end;
  for S:=IR1 to V do
   begin
    Z := BG*AI[(S-1)+(R-1)*N]+BF*AR[(S-1)+(R-1)*N];
    AR[(S-1)+(R-1)*N] := BG*AR[(S-1)+(R-1)*N]-BF*AI[(S-1)+(R-1)*N];
    AI[(S-1)+(R-1)*N] := Z;
_14:
   end;
_15:
 end;
_16:
for R:=1 to N do
 begin
  if ( R >= IR1 ) and ( R <= IR2 ) 
   then goto _17;
  EVR[R-1] := AR[(R-1)+(R-1)*N];
  EVI[R-1] := AI[(R-1)+(R-1)*N];
_17:
 end;
U := IR2;
BC := 0.0;
BB := 0.0;
_18:
if ( U < IR1 ) 
 then goto _35;
W := 0;
Y := U-1;
_19:
for V:=IR1 to U do
 begin
  T := U+IR1-V;
  if ( T = IR1 ) 
   then goto _21;
  if ( Abs(AR[(T-1)+(T-2)*N]) <= SYS051*(Abs(AR[(T-2)+(T-2)*N])+
       Abs(AI[(T-2)+(T-2)*N])+Abs(AR[(T-1)+(T-1)*N])+Abs(AI[(T-1)+(T-1)*N])) ) 
   then goto _21;
_20:
 end;
_21:
if ( T = U ) 
 then goto _33;
if ( W = 30 ) 
 then goto _34;
if ( W = 10 ) or ( W = 20 ) 
 then goto _23;
BA := AR[(U-1)+(U-1)*N];
Z := AI[(U-1)+(U-1)*N];
BE := AR[(Y-1)+(U-1)*N]*AR[(U-1)+(Y-1)*N];
BD := AI[(Y-1)+(U-1)*N]*AR[(U-1)+(Y-1)*N];
if ( BE = 0.0 ) and ( BD = 0.0 ) 
 then goto _24;
BG := (AR[(Y-1)+(Y-1)*N]-BA)/2.0;
BF := (AI[(Y-1)+(Y-1)*N]-Z)/2.0;
BL := Csqrt(Cmplx(IntPower(BG,2)-IntPower(BF,2)+BE,2.0*BG*BF+BD));
BI := Creal(BL);
BH := Aimag(BL);
if ( BG*BI+BF*BH >= 0.0 ) 
 then goto _22;
BI := -BI;
BH := -BH;
_22:
BL := DivC(Cmplx(BE,BD),Cmplx(BG+BI,BF+BH));
BA := BA-Creal(BL);
Z := Z-Aimag(BL);
goto _24;
_23:
BA := Abs(AR[(U-1)+(Y-1)*N])+Abs(AR[(Y-1)+(U-3)*N]);
Z := 0.0;
_24:
for R:=IR1 to U do
 begin
  AR[(R-1)+(R-1)*N] := AR[(R-1)+(R-1)*N]-BA;
  AI[(R-1)+(R-1)*N] := AI[(R-1)+(R-1)*N]-Z;
_25:
 end;
BC := BC+BA;
BB := BB+Z;
W := W+1;
X := T+1;
for R:=X to U do
 begin
  BA := AR[(R-1)+(R-2)*N];
  AR[(R-1)+(R-2)*N] := 0.0;
  BJ := Sqrt(AR[(R-2)+(R-2)*N]*AR[(R-2)+(R-2)*N]+AI[(R-2)+(R-2)*N]*AI[(R-1-1)+(R-
    1-1)*N]+BA*BA);
  BE := AR[(R-2)+(R-2)*N]/BJ;
  EVR[R-2] := BE;
  BD := AI[(R-2)+(R-2)*N]/BJ;
  EVI[R-2] := BD;
  AR[(R-2)+(R-2)*N] := BJ;
  AI[(R-2)+(R-2)*N] := 0.0;
  AI[(R-1)+(R-2)*N] := BA/BJ;
  for S:=R to U do
   begin
    BG := AR[(R-2)+(S-1)*N];
    BF := AI[(R-2)+(S-1)*N];
    BI := AR[(R-1)+(S-1)*N];
    BH := AI[(R-1)+(S-1)*N];
    AR[(R-2)+(S-1)*N] := BE*BG+BD*BF+AI[(R-1)+(R-2)*N]*BI;
    AI[(R-2)+(S-1)*N] := BE*BF-BD*BG+AI[(R-1)+(R-2)*N]*BH;
    AR[(R-1)+(S-1)*N] := BE*BI-BD*BH-AI[(R-1)+(R-2)*N]*BG;
    AI[(R-1)+(S-1)*N] := BE*BH+BD*BI-AI[(R-1)+(R-2)*N]*BF;
_26:
   end;
_27:
 end;
Z := AI[(U-1)+(U-1)*N];
if ( Z = 0.0 ) 
 then goto _28;
BJ := Cabs(Cmplx(AR[(U-1)+(U-1)*N],Z));
BA := AR[(U-1)+(U-1)*N]/BJ;
Z := Z/BJ;
AR[(U-1)+(U-1)*N] := BJ;
AI[(U-1)+(U-1)*N] := 0.0;
_28:
for S:=X to U do
 begin
  BE := EVR[S-2];
  BD := EVI[S-2];
  for R:=T to S do
   begin
    BG := AR[(R-1)+(S-2)*N];
    BF := 0.0;
    BI := AR[(R-1)+(S-1)*N];
    BH := AI[(R-1)+(S-1)*N];
    if ( R = S ) 
     then goto _29;
    BF := AI[(R-1)+(S-2)*N];
    AI[(R-1)+(S-2)*N] := BE*BF+BD*BG+AI[(S-1)+(S-2)*N]*BH;
_29:
    AR[(R-1)+(S-2)*N] := BE*BG-BD*BF+AI[(S-1)+(S-2)*N]*BI;
    AR[(R-1)+(S-1)*N] := BE*BI+BD*BH-AI[(S-1)+(S-2)*N]*BG;
    AI[(R-1)+(S-1)*N] := BE*BH-BD*BI-AI[(S-1)+(S-2)*N]*BF;
_30:
   end;
_31:
 end;
if ( Z = 0.0 ) 
 then goto _19;
for R:=T to U do
 begin
  BG := AR[(R-1)+(U-1)*N];
  BF := AI[(R-1)+(U-1)*N];
  AR[(R-1)+(U-1)*N] := BA*BG-Z*BF;
  AI[(R-1)+(U-1)*N] := BA*BF+Z*BG;
_32:
 end;
goto _19;
_33:
EVR[U-1] := AR[(U-1)+(U-1)*N]+BC;
EVI[U-1] := AI[(U-1)+(U-1)*N]+BB;
U := Y;
goto _18;
_34:
IERR := U;
_35:
if ( IERR <> 0 ) 
 then UTAE10(IERR,N,30);
end;

end.
